var refreshTimer;
var msgObj = null;
var criteria = new Object();

function init() {
    try{
        msgObj = nokia.device.load("messaging");
    } catch (e){
		document.getElementById('time1').innerHTML = "Error getting messaging service object: "+e;
        return;
    }
	if (widget.isrotationsupported)
    {
        widget.setDisplayPortrait();
    }
    window.menu.hideSoftkeys();
	criteria.Type = "SMS";
	update();
	widget.onshow = update;
    try{
		var ret = msgObj.setNotifier(update);
	}
	catch(e){
		document.getElementById('time1').innerHTML =  "error: "+e;
	}
}

function update()
{
    window.widget.prepareForTransition("fade");
	
    try {
		msgObj.getList(updateCB, criteria, msgObj.SORT_BY_DATE, msgObj.SORT_DESCENDING);
	}
	catch(e) {
		document.getElementById('time1').innerHTML = "Error getting sms list: "+e;
	}
}

function updateCB(msgiterator)
{
	try {
		var i=1;
		var sms;
		while (sms = msgiterator.next()) {
			var day = null;
			var month = null;
			var array = sms.time.split(", ");
			var wtf = array[1].substring(1).split(" ");
			if (isNaN(parseInt(wtf[0]))) {
				if (wtf[0].length > 3) month = wtf[0].substring(0,3);
				else month = wtf[0];
				if (wtf[1].length < 4) day = wtf[1];
			}
			else if (isNaN(parseInt(wtf[1]))) {
				if (wtf[1].length > 3) month = wtf[1].substring(0,3);
				else month = wtf[1];
				if (wtf[0].length < 4) day = wtf[0];
			}
			
			if (day == null) day = array[2].substring(0,2);
			else if (month == null) month = array[2].substring(0,3);
			
			var time = array[2].substring(array[2].indexOf(" "));
			var ampm = "";
			if (time.indexOf("AM") != -1) ampm = " AM";
			else if (time.indexOf("PM") != -1) ampm = " PM";
			var regex = /\d*[:\.]\d\d/;
			time = time.match(regex);
			dateTime = day + " " + month + " " + time + ampm;
			
			var content = sms.message.body;
			if (sms.unread) {
				document.getElementById('content'+i).style.fontWeight = "bold";
			}
			else {
				document.getElementById('content'+i).style.fontWeight = "normal";
			}
			document.getElementById('time'+i).innerHTML = dateTime+" ";
			document.getElementById('sender'+i).innerHTML = sms.sender+" ";
			document.getElementById('content'+i).innerHTML = content;
			
			var timeElement = document.getElementById('time'+i);
			var senderElement = document.getElementById('sender'+i);
			var contentElement = document.getElementById('content'+i);
			
			var truncated = false;
			while (timeElement.clientWidth + senderElement.clientWidth + contentElement.clientWidth > 285 && content.length > 0) {
				content = content.substring(0, content.length-1);
				contentElement.innerHTML = content;
				truncated = true;
			}
			if (truncated) document.getElementById('content'+i).innerHTML = content + "...";
			if (++i>4) break;
		}
	}
	catch(e) {
		alert("Messaging exception: " + e);
	}
	window.widget.performTransition();
}

function setViewMode()
{
	if (window.innerHeight > 150)
    {
		window.close();
        widget.openApplication(0x2002A540);
    }
}